# array.py - array example
#
# Copyright (C) 2001-2004 Federico Di Gregorio  <fog@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

## put in DSN your DSN string

DSN = 'dbname=test'

## don't modify anything below tis line (except for experimenting)

import sys, psycopg

if len(sys.argv) > 1:
    DSN = sys.argv[1]

print "Opening connection using dns:", DSN
conn = psycopg.connect(DSN)
curs = conn.cursor()

try:
    curs.execute("""CREATE TABLE test_array (
                      ar1 integer[], ar2 text[], ar3 float[][])""")
except:
    conn.rollback()
    curs.execute("DROP TABLE test_array")
    curs.execute("""CREATE TABLE test_array (
                      ar1 integer[], ar2 text[], ar3 float[][])""")
conn.commit()

curs.execute("INSERT INTO test_array VALUES (%s, %s, %s)",
             ('{1,2,3}', "{'uno', 'due', 'tre'}",
              '{{3.14, 2.72}, {3.14, 2.72}, {0, 0}}'))
curs.execute("UPDATE test_array SET ar3[1][1:2] = ARRAY[2.72, 3.14]")

curs.execute("SELECT * FROM test_array")

print "Some information about the retrieved data:"
for d in curs.description:
    print d[0], "oid:", d[1]

print "And now the data (they should be list!):"
for x in curs.fetchone():
    print " ", x

curs.execute("DROP TABLE test_array")
conn.commit()
